from netfilterqueue import NetfilterQueue
from socket import fromfd, AF_UNIX, SOCK_STREAM
from binascii import b2a_hex
from time import sleep
from scapy.all import *
from pickle import load
from getmac import get_mac_address
from time import time

_model = load(open('./devices/f4.b8.5e.5f.a9.57/live_stream/training.model', 'rb'))[0]
_models = {}

_models['F4:B8:5E:5F:A9:57'] = []
_models['F4:B8:5E:5F:A9:57'].append(_model)

_models['AC:84:C6:C9:2A:89'] = []
_models['AC:84:C6:C9:2A:89'].append(_model)

print(_models)

def get_src_mac(nfq_packet):
    mac_string = b2a_hex(nfq_packet.get_hw()).decode('ascii')[0:12].upper()
    return ':'.join(mac_string[i:i+2] for i in range (0, len(mac_string), 2))
    
def make_prediction(model, list):
    return model.predict([list])
    
def handle_nfq_packet(raw_packet):
    start = time()
    packet = IP(raw_packet.get_payload())
    size = raw_packet.get_payload_len() + 16
    src_mac = get_src_mac(raw_packet)
    
    for model in _models[src_mac]:
        p = make_prediction(model, [size, 0])
        print(src_mac, p)
    
    raw_packet.accept()
    print(time() - start)
    print('')
    

    #src_mac = get_src_mac(raw_packet)
    #print(src_mac)
    #print(raw_packet)
    #print(IP(raw_packet.get_payload()).summary())
    #print('')
    #sleep(1)
    #raw_packet.accept()

#     src_mac = get_src_mac(nfq_packet)
#     nfq_packet.drop()
#     #print(src_mac)
#     #sleep(2)
#     scp_packet = IP(nfq_packet.get_payload())
#     print(scp_packet.show())
#     send(scp_packet)
#     #nfq_packet.accept()

def main():
    nfqueue = NetfilterQueue()
    nfqueue.bind(1, handle_nfq_packet)
    nfqueue.bind(2, handle_nfq_packet)
    try:
        print('Starting...')
        nfqueue.run()
    except KeyboardInterrupt:
        nfqueue.unbind()
        exit(0)

    '''
    nfqueue = NetfilterQueue()
    nfqueue.bind(1, handle_nfq_packet)
    s = fromfd(nfqueue.get_fd(), AF_UNIX, SOCK_STREAM)
    
    try:
        print('Filtering has started')
        nfqueue.run_socket(s)
    except KeyboardInterrupt:
        s.close()
        nfqueue.unbind()
        exit(0)
    '''
    
main()