echo 'Collecting online MAC addresses'
for mac_address in $(sudo nmap -sP 192.168.4.0/24 | grep -o "\([0-9A-Fa-f]\{2\}:\)\{5\}[0-9A-Fa-f]\{2\}")
do
    formatted_mac_address=$(echo $mac_address | awk '{print tolower($0)}' | tr ":" ".")
    
    temp_pcap="p0f/temp/temp.pcap"
    p0f_binary="./p0f/p0f-3.09b/p0f"
    p0f_fp="p0f/p0f-3.09b/p0f.fp"
    p0f_log="p0f/temp/"$formatted_mac_address".p0f.log"
    p0f_json="p0f_json/"$formatted_mac_address".p0f.json"
    p0f_python="p0f/log_to_json.py"
    
    echo 'Collecting packets from '$mac_address &&
    # timeout sends an interrupt to process, can't pair subsequent command with &&
    sudo timeout 30s tcpdump -i wlan0 -w $temp_pcap ether src host $mac_address &> /dev/null
    echo 'Assessing collected packets with p0f' &&
    sudo $p0f_binary -f $p0f_fp -r $temp_pcap -o $p0f_log &> /dev/null &&
    sudo chown pi:pi $p0f_log &&
    echo 'Regular expression matching with Python'
    python $p0f_python $p0f_log p0f_json &> /dev/null &&
    sudo rm -f $temp_pcap $p0f_log &&
    echo 'Done'
    
done