from json import dump
from sys import argv
from re import findall
from os.path import join

LOG_FILE = argv[1]
JSON_FOLDER = argv[2]

with open(LOG_FILE) as log:
    json = {}
    contents = log.read()
    
    os_guesses = findall("[|] os[^=]*[=] ([^\n\?]+)[\n]", contents)
    map_os_guesses = {}
    for guess in os_guesses:
        map_os_guesses[guess] = os_guesses.count(guess)
    json['os_guesses'] = map_os_guesses
    
    mac_address = LOG_FILE.split('/')[-1].split('.p0f.log')[0]
    dump_path = join(JSON_FOLDER, "%s%s" % (mac_address, '.p0f.json'))
    with open(dump_path, 'w') as dump_file:
        dump(json, dump_file)
